Subject: [PATCHv7 01/11] clockevents: Prefer CPU local devices over global devices

From: [email-masked] (Stephen Boyd)
Date: Thu, 13 Jun 2013 11:39:50 -0700

On 06/13, Thomas Gleixner wrote:
> On Thu, 13 Jun 2013, Daniel Lezcano wrote:
> > I prefer Thomas to have a look at it and ack it. I changed Cc to To for
> > Thomas.
> 
> The patch does not apply on tip timers/core. The code has been
> reworked a month ago. Please work against tip timers/core. That's
> where this stuff ends up.
> 

Ah, I thought your patch series had stalled. Here is a refreshed
patch. Every other patch in this series applies cleanly to tip
timers/core so I don't want to resend them again unless
absolutely necessary.

-----8<-----
Subject: [PATCH v8] clockevents: Prefer CPU local devices over global devices

On an SMP system with only one global clockevent and a dummy
clockevent per CPU we run into problems. We want the dummy
clockevents to be registered as the per CPU tick devices, but
we can only achieve that if we register the dummy clockevents
before the global clockevent or if we artificially inflate the
rating of the dummy clockevents to be higher than the rating
of the global clockevent. Failure to do so leads to boot
hangs when the dummy timers are registered on all other CPUs
besides the CPU that accepted the global clockevent as its tick
device and there is no broadcast timer to poke the dummy
devices.

If we're registering multiple clockevents and one clockevent is
global and the other is local to a particular CPU we should
choose to use the local clockevent regardless of the rating of
the device. This way, if the clockevent is a dummy it will take
the tick device duty as long as there isn't a higher rated tick
device and any global clockevent will be bumped out into
broadcast mode, fixing the problem described above.

Reported-by: Mark Rutland <[email-masked]>
Cc: John Stultz <[email-masked]>
Cc: Thomas Gleixner <[email-masked]>
Cc: Daniel Lezcano <[email-masked]>
Signed-off-by: Stephen Boyd <[email-masked]>
---
 kernel/time/tick-common.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

diff --git a/kernel/time/tick-common.c b/kernel/time/tick-common.c
index 5edfb48..edd45f6 100644
--- a/kernel/time/tick-common.c
+++ b/kernel/time/tick-common.c
@@ -243,8 +243,13 @@ static bool tick_check_preferred(struct clock_event_device *curdev,
 			return false;
 	}
 
-	/* Use the higher rated one */
-	return !curdev || newdev->rating > curdev->rating;
+	/*
+	 * Use the higher rated one, but prefer a CPU local device with a lower
+	 * rating than a non-CPU local device
+	 */
+	return !curdev ||
+		newdev->rating > curdev->rating ||
+	       !cpumask_equal(curdev->cpumask, newdev->cpumask);
 }
 
 /*

-- 
Qualcomm Innovation Center, Inc. is a member of Code Aurora Forum,
hosted by The Linux Foundation